$(window).ready(function(){
    
    function verificaBtnSubmit(){
        if($("#fileInput").get(0).files.length === 0)
        {
            $("#btnSubmit").prop('disabled', 'true');
        }else
        {
            $("#btnSubmit").prop('disabled','');
        }
    }

    function verificaBtnCancela(){
        let comArquivo = $("#fileInput").get(0).files.length > 0;
        let checkedSpiffs = $("#cb_spiffsOuFlash").is(":checked");
        if(checkedSpiffs || comArquivo)
        {
            $("#buttonCancela").prop('disabled',''); // habilita
        }else
        {
            $("#buttonCancela").prop('disabled', 'true'); // desabilita
        }
    }
    
    function verificaBtns(){
        verificaBtnSubmit();
        verificaBtnCancela();
    }

    function setPercentageInProgressBar(value){
        if(value >=0 && value <=100){
            $('#progressbar_interior').css('width', value+"%");
            $('#progressbar_interior').text(value+"%");
        }else if(value > 100){
            $('#progressbar_interior').css('width', "100%");
            $('#progressbar_interior').text("100%");
        }
        else if(value < 0){
            $('#progressbar_interior').css('width', "0%");
            $('#progressbar_interior').text("0%");
        }
    }

    verificaBtns();

    $('#messageForUser').css({
        display: 'none'
    });

    $('#progressBar').css({
        display: 'none'
    });

    $("#fileInput").on("change",verificaBtns);

    $("#cb_spiffsOuFlash").on("change",verificaBtns);
    
    $("#buttonCancela").on('click', function(event) {
        event.preventDefault();
        $("#cb_spiffsOuFlash").prop('checked','');
        $("#fileInput").prop('value','');
        verificaBtns();
    });

    $('#btnSubmit').on('click', function(event) {
        event.preventDefault();
        
        let comArquivo = $("#fileInput").get(0).files.length > 0;
        if(comArquivo)
        {
            $('#progressBar').css({
                display: ''
            });
        
            let checkedSpiffs = $("#cb_spiffsOuFlash").is(":checked");
            let urlServer = checkedSpiffs ? "/atualizar-spiffs" : "/atualizar-flash";
            var form = $('#upload_form')[0];
            var _data = new FormData(form);
            jQuery.each(jQuery('#fileInput')[0].files, function(i, file) {
                _data.append('file-'+i, file);
            });

            $.ajax({
                method: 'POST',
                type: "POST",
                url: urlServer,
                cache:false,
                data: _data,
                contentType: false,
                processData: false,
                xhr: function(){
                    var xhr = new window.XMLHttpRequest();
                    xhr.upload.addEventListener('progress', function(evt) {
                        if (evt.lengthComputable) {
                            let per = evt.loaded / evt.total;
                            $('#progressbar_interior').css('width', Math.round(per*100) + '%');
                            $('#progressbar_interior').html(Math.round(per*100) + '%');
                            per = Math.round(per*100);
                            setPercentageInProgressBar(per);
                            if(per == 100){
                                alert('Upload concluído. Espere algum tempo para que o servidor volte à operar.');
                                var idTime = setTimeout(function(){window.location.href = "/";clearInterval(idTime);},2000);
                            }
                        }
                    });

                    return xhr;
                }
            })
            .done(function(data){
                // SUCESSO
                $('#messageForUser').css({
                    display: ''
                });
                $('#messageForUser').text('O Firmware foi enviado com sucesso!. Você irá ser redirecionado para a página principal do Servidor em alguns instantes');
            })
            .fail(function(jqXHR, textStatus){
                // Mensagem de Erro
                $('#messageForUser').css({
                    display: ''
                });
                $('#messageForUser').text('O envio ao servidor apresentou um erro. Verifique a conexão elétrica do ESP32.');
            });
        }else
        {
            alert("É necessário selecionar um arquivo para envio");
        }
    });
});